# Begin OSD conversion.  Run on each node that has OSDS
function upgrade_mds () {

ceph fs ls
ceph orch ps --daemon-type mds
ceph fs status 
read -t 300 -p "Pausing to provide output for review"

date=$(date +%m%e.%H%M)
echo "Backing up the Ceph MDS Journal"
cephfs-journal-tool --rank cephfs:all  journal export /root/backup.$date.bin


export standby_mdss=$(ceph fs dump -f json-pretty|jq -r '.standbys|map(.name)|join(" ")')
export active_mds=$(ceph fs status -f json-pretty|jq -r '.mdsmap[]|select(.state=="active")|.name')
export mds_cluster="$active_mds $standby_mdss"
ceph fs set cephfs max_mds 1

echo "Active MDS is: $active_mds"
echo "Standby MDS(s) are: $standby_mdss"
echo "Full Cluster: $mds_cluster"
let count=0
# stop standby mds instances
for host in $mds_cluster
do
 echo "stopping Standby MDS on $host"
 ((count++))
 host_list="$host $host_list"
 ssh $host 'systemctl stop ceph-mds.target && rm -rf /var/lib/ceph/mds/ceph-*'
 echo "adding standby MDS(s) via ceph orcherator"
 ceph orch apply mds cephfs --placement="$count $host_list"
 echo "sleeping 20 seconds to allow mds on $host to start"
 sleep 20
 ceph fs status 
 read -t 300 -p "Pausing to provide output for review"
 new_active=$(ceph fs status -f json-pretty|jq '.mdsmap[]|select(.state=="active")|.name')
 echo "old active MDS was $active_mds and the NEW active MDS is $new_active"
done

echo "Standby MDS status:\n $(ceph fs dump -f json-pretty|jq -r '.standbys|map(.name)|join(" ")')"
# put in check to make sure the stanbys are active

read -t 300 -p "Pausing to allow the New active MDS to start completely"


# New
# In Pacific release - ceph fs set <fs_name> allow_standby_replay false
#
# convert standbys then active   see https://docs.ceph.com/en/latest/cephfs/upgrading/
#ceph fs dump # find standby-replay daemons
#ceph mds fail mds.<X>
#ceph fs set <fs_name> max_mds 1
#ceph status # wait for MDS to finish stopping
# will need jq fu here.

#ceph orch apply mds cephfs --placement="3 $(ceph node ls |jq -r '.mon|map(.[])|join(" ")')"
ceph orch ps --daemon-type mds
}

